"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _FlowContext = require("../FlowContext");

var _calculators = require("../calculators");

var _collection = require("../schemas/collection");

var _CollectionFieldSelect = _interopRequireDefault(require("../components/CollectionFieldSelect"));

var _locale = require("../locale");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = {
  title: `{{t("Query record", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'query',
  group: 'collection',
  fieldset: {
    'config.collection': _collection.collection,
    'config.multiple': {
      type: 'boolean',
      title: `{{t("Multiple records", { ns: "${_locale.NAMESPACE}" })}}`,
      name: 'config.multiple',
      'x-decorator': 'FormItem',
      'x-component': 'Checkbox',
      'x-component-props': {
        disabled: true
      }
    },
    'config.params': {
      type: 'object',
      name: 'config.params',
      title: '',
      'x-decorator': 'FormItem',
      properties: {
        filter: _collection.filter
      }
    }
  },
  view: {},
  scope: {
    useCollectionDataSource: _client().useCollectionDataSource
  },
  components: {
    VariableComponent: _calculators.VariableComponent
  },

  getter(props) {
    const _onChange = props.onChange;

    const _useFlowContext = (0, _FlowContext.useFlowContext)(),
          nodes = _useFlowContext.nodes;

    const _useOperandContext = (0, _calculators.useOperandContext)(),
          options = _useOperandContext.options;

    const _nodes$find = nodes.find(n => n.id == options.nodeId),
          config = _nodes$find.config;

    const value = options === null || options === void 0 ? void 0 : options.path;
    return _react().default.createElement(_CollectionFieldSelect.default, {
      collection: config.collection,
      value: value,
      onChange: path => {
        _onChange(`{{$jobsMapByNodeId.${options.nodeId}.${path}}}`);
      }
    });
  }

};
exports.default = _default;