"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _locale = require("../locale");

function _antd() {
  const data = require("@formily/antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

var _EjsTextArea = _interopRequireDefault(require("../components/EjsTextArea"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = {
  title: `{{t("HTTP request", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'request',
  group: 'extended',
  fieldset: {
    'config.url': {
      type: 'string',
      name: 'config.url',
      required: true,
      title: `{{t("URL", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-decorator-props': {},
      'x-component': 'EjsTextArea',
      'x-component-props': {
        autoSize: {
          minRows: 1
        },
        placeholder: 'https://xxxxxx',
        description: `{{t("You can use the above available variables in URL.", { ns: "${_locale.NAMESPACE}" })}}`
      }
    },
    'config.timeout': {
      type: 'number',
      name: 'config.timeout',
      required: true,
      title: `{{t("Timeout config", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-decorator-props': {},
      'x-component': 'InputNumber',
      'x-component-props': {
        addonAfter: `{{t("ms", { ns: "${_locale.NAMESPACE}" })}}`,
        min: 1,
        step: 1000,
        defaultValue: 5000
      }
    },
    'config.headers': {
      type: 'array',
      name: 'config.headers',
      'x-component': 'ArrayItems',
      'x-decorator': 'FormItem',
      title: `{{t("Request headers", { ns: "${_locale.NAMESPACE}" })}}`,
      description: `{{t("Default headers is Content-Type: application/json", { ns: "${_locale.NAMESPACE}" })}}`,
      items: {
        type: 'object',
        properties: {
          space: {
            type: 'void',
            'x-component': 'Space',
            properties: {
              name: {
                type: 'string',
                'x-decorator': 'FormItem',
                'x-component': 'Input',
                'x-component-props': {
                  placeholder: `{{t("Name(e.g. Content-Type)", { ns: "${_locale.NAMESPACE}" })}}`
                }
              },
              value: {
                type: 'string',
                'x-decorator': 'FormItem',
                'x-component': 'Input',
                'x-component-props': {
                  placeholder: `{{t("Value(e.g. Application/json)", { ns: "${_locale.NAMESPACE}" })}}`
                }
              },
              remove: {
                type: 'void',
                'x-decorator': 'FormItem',
                'x-component': 'ArrayItems.Remove'
              }
            }
          }
        }
      },
      properties: {
        add: {
          type: 'void',
          title: `{{t("Add request header", { ns: "${_locale.NAMESPACE}" })}}`,
          'x-component': 'ArrayItems.Addition'
        }
      }
    },
    'config.method': {
      type: 'string',
      name: 'config.method',
      required: true,
      title: `{{t("HTTP method", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Select',
      'x-component-props': {
        defaultValue: 'POST',
        showSearch: false,
        allowClear: false
      },
      enum: [{
        label: 'GET',
        value: 'GET'
      }, {
        label: 'POST',
        value: 'POST'
      }, {
        label: 'PUT',
        value: 'PUT'
      }, {
        label: 'PATCH',
        value: 'PATCH'
      }, {
        label: 'DELETE',
        value: 'DELETE'
      }]
    },
    'config.data': {
      type: 'string',
      name: 'config.data',
      'x-hidden': false,
      title: `{{t("Request data", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-decorator-props': {},
      'x-component': 'EjsTextArea',
      'x-component-props': {
        autoSize: {
          minRows: 5
        },
        placeholder: `{{t("Input request data", { ns: "${_locale.NAMESPACE}" })}}`,
        description: `{{t("You can use the above available variables in request data.", { ns: "${_locale.NAMESPACE}" })}}`
      }
    },
    'config.ignoreFail': {
      type: 'boolean',
      name: 'config.ignoreFail',
      title: `{{t("Ignore fail request and continue workflow", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Checkbox'
    }
  },
  view: {},
  scope: {},
  components: {
    ArrayItems: _antd().ArrayItems,
    EjsTextArea: _EjsTextArea.default
  }
};
exports.default = _default;