"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _path() {
  const data = _interopRequireDefault(require("path"));

  _path = function _path() {
    return data;
  };

  return data;
}

function _database() {
  const data = require("@nocobase/database");

  _database = function _database() {
    return data;
  };

  return data;
}

function _server() {
  const data = require("@nocobase/server");

  _server = function _server() {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("@nocobase/utils");

  _utils = function _utils() {
    return data;
  };

  return data;
}

var _actions = _interopRequireDefault(require("./actions"));

var _calculators = _interopRequireDefault(require("./calculators"));

var _constants = require("./constants");

var _extensions = _interopRequireDefault(require("./extensions"));

var _instructions = _interopRequireDefault(require("./instructions"));

var _Processor = _interopRequireDefault(require("./Processor"));

var _triggers = _interopRequireDefault(require("./triggers"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

class WorkflowPlugin extends _server().Plugin {
  constructor(...args) {
    var _this;

    super(...args);
    _this = this;
    this.instructions = new (_utils().Registry)();
    this.triggers = new (_utils().Registry)();
    this.calculators = _calculators.default;
    this.extensions = _extensions.default;
    this.executing = null;
    this.pending = [];
    this.events = [];

    this.onBeforeSave = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator(function* (instance, options) {
        const Model = instance.constructor;

        if (instance.enabled) {
          instance.set('current', true);
        } else if (!instance.current) {
          const count = yield Model.count({
            where: {
              key: instance.key
            },
            transaction: options.transaction
          });

          if (!count) {
            instance.set('current', true);
          }
        }

        if (!instance.changed('enabled') || !instance.enabled) {
          return;
        }

        const previous = yield Model.findOne({
          where: {
            key: instance.key,
            current: true,
            id: {
              [_database().Op.ne]: instance.id
            }
          },
          transaction: options.transaction
        });

        if (previous) {
          // NOTE: set to `null` but not `false` will not violate the unique index
          yield previous.update({
            enabled: false,
            current: null
          }, {
            transaction: options.transaction,
            hooks: false
          });

          _this.toggle(previous, false);
        }
      });

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }();

    this.prepare = /*#__PURE__*/_asyncToGenerator(function* () {
      var _options$context;

      const event = _this.events.shift();

      if (!event) {
        return;
      }

      const _event = _slicedToArray(event, 3),
            workflow = _event[0],
            context = _event[1],
            options = _event[2];

      if ((_options$context = options.context) === null || _options$context === void 0 ? void 0 : _options$context.executionId) {
        // NOTE: no transaction here for read-uncommitted execution
        const existed = yield workflow.countExecutions({
          where: {
            id: options.context.executionId
          }
        });

        if (existed) {
          console.warn(`workflow ${workflow.id} has already been triggered in same execution (${options.context.executionId}), and newly triggering will be skipped.`);
          return;
        }
      }

      const execution = yield _this.db.sequelize.transaction( /*#__PURE__*/function () {
        var _ref3 = _asyncToGenerator(function* (transaction) {
          const execution = yield workflow.createExecution({
            context,
            key: workflow.key,
            status: _constants.EXECUTION_STATUS.CREATED,
            useTransaction: workflow.useTransaction
          }, {
            transaction
          });
          const executed = yield workflow.countExecutions({
            transaction
          }); // NOTE: not to trigger afterUpdate hook here

          yield workflow.update({
            executed
          }, {
            transaction,
            hooks: false
          });
          const allExecuted = yield execution.constructor.count({
            where: {
              key: workflow.key
            },
            transaction
          });
          yield workflow.constructor.update({
            allExecuted
          }, {
            where: {
              key: workflow.key
            },
            individualHooks: true,
            transaction
          });
          execution.workflow = workflow;
          return execution;
        });

        return function (_x3) {
          return _ref3.apply(this, arguments);
        };
      }()); // NOTE: cache first execution for most cases

      if (!_this.executing && !_this.pending.length) {
        _this.pending.push([execution]);
      }

      if (_this.events.length) {
        yield _this.prepare();
      } else {
        _this.dispatch();
      }
    });
  }

  load() {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      const db = _this2.db,
            options = _this2.options;
      yield db.import({
        directory: _path().default.resolve(__dirname, 'collections')
      });

      _this2.db.addMigrations({
        namespace: 'workflow',
        directory: _path().default.resolve(__dirname, 'migrations'),
        context: {
          plugin: _this2
        }
      });

      (0, _actions.default)(_this2);
      (0, _triggers.default)(_this2, options.triggers);
      (0, _instructions.default)(_this2, options.instructions);
      db.on('workflows.beforeSave', _this2.onBeforeSave);
      db.on('workflows.afterSave', model => _this2.toggle(model));
      db.on('workflows.afterDestroy', model => _this2.toggle(model, false));

      _this2.app.on('afterLoad', /*#__PURE__*/_asyncToGenerator(function* () {
        _this2.extensions.reduce((promise, extend) => promise.then(() => extend(_this2)), Promise.resolve());
      })); // [Life Cycle]:
      //   * load all workflows in db
      //   * add all hooks for enabled workflows
      //   * add hooks for create/update[enabled]/delete workflow to add/remove specific hooks


      _this2.app.on('beforeStart', /*#__PURE__*/_asyncToGenerator(function* () {
        const collection = db.getCollection('workflows');
        const workflows = yield collection.repository.find({
          filter: {
            enabled: true
          }
        });
        workflows.forEach(workflow => {
          _this2.toggle(workflow);
        }); // check for not started executions

        _this2.dispatch();
      }));

      _this2.app.on('beforeStop', /*#__PURE__*/_asyncToGenerator(function* () {
        const collection = db.getCollection('workflows');
        const workflows = yield collection.repository.find({
          filter: {
            enabled: true
          }
        });
        workflows.forEach(workflow => {
          _this2.toggle(workflow, false);
        });
      }));
    })();
  }

  toggle(workflow, enable) {
    const type = workflow.get('type');
    const trigger = this.triggers.get(type);

    if (typeof enable !== 'undefined' ? enable : workflow.get('enabled')) {
      // NOTE: remove previous listener if config updated
      const prev = workflow.previous();

      if (prev.config) {
        trigger.off(_objectSpread(_objectSpread({}, workflow.get()), prev));
      }

      trigger.on(workflow);
    } else {
      trigger.off(workflow);
    }
  }

  trigger(workflow, context, options = {}) {
    // `null` means not to trigger
    if (context == null) {
      return;
    }

    this.events.push([workflow, context, options]);

    if (this.events.length > 1) {
      return;
    } // NOTE: no await for quick return


    setTimeout(this.prepare);
  }

  resume(job) {
    var _this3 = this;

    return _asyncToGenerator(function* () {
      if (!job.execution) {
        job.execution = yield job.getExecution();
      }

      _this3.pending.push([job.execution, job]);

      _this3.dispatch();
    })();
  }

  dispatch() {
    var _this4 = this;

    return _asyncToGenerator(function* () {
      if (_this4.executing) {
        return;
      }

      let next = null; // resuming has high priority

      if (_this4.pending.length) {
        next = _this4.pending.shift();
      } else {
        const execution = yield _this4.db.getRepository('executions').findOne({
          filter: {
            status: _constants.EXECUTION_STATUS.CREATED
          },
          sort: 'createdAt'
        });

        if (execution) {
          next = [execution];
        }
      }

      ;

      if (next) {
        _this4.process(...next);
      }
    })();
  }

  process(execution, job) {
    var _this5 = this;

    return _asyncToGenerator(function* () {
      _this5.executing = execution;

      if (execution.status === _constants.EXECUTION_STATUS.CREATED) {
        yield execution.update({
          status: _constants.EXECUTION_STATUS.STARTED
        });
      }

      const processor = _this5.createProcessor(execution);

      console.log('workflow processing:', new Date(), execution.workflowId, execution.id);
      yield job ? processor.resume(job) : processor.start();
      _this5.executing = null;

      _this5.dispatch();
    })();
  }

  createProcessor(execution, options = {}) {
    return new _Processor.default(execution, _objectSpread(_objectSpread({}, options), {}, {
      plugin: this
    }));
  }

}

exports.default = WorkflowPlugin;